// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * ESS inverter high level function to maintain frequency within dead bands.
 * </pre>
 *
 * Protobuf type {@code essmodule.FrequencyRegulation}
 */
public final class FrequencyRegulation extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.FrequencyRegulation)
    FrequencyRegulationOrBuilder {
private static final long serialVersionUID = 0L;
  // Use FrequencyRegulation.newBuilder() to construct.
  private FrequencyRegulation(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private FrequencyRegulation() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new FrequencyRegulation();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_FrequencyRegulation_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_FrequencyRegulation_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.FrequencyRegulation.class, openfmb.essmodule.FrequencyRegulation.Builder.class);
  }

  public static final int FREQUENCYDEADBANDMINUS_FIELD_NUMBER = 1;
  private com.google.protobuf.FloatValue frequencyDeadBandMinus_;
  /**
   * <pre>
   * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
   * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
   * DB = frequency set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
   * @return Whether the frequencyDeadBandMinus field is set.
   */
  @java.lang.Override
  public boolean hasFrequencyDeadBandMinus() {
    return frequencyDeadBandMinus_ != null;
  }
  /**
   * <pre>
   * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
   * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
   * DB = frequency set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
   * @return The frequencyDeadBandMinus.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getFrequencyDeadBandMinus() {
    return frequencyDeadBandMinus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : frequencyDeadBandMinus_;
  }
  /**
   * <pre>
   * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
   * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
   * DB = frequency set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getFrequencyDeadBandMinusOrBuilder() {
    return frequencyDeadBandMinus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : frequencyDeadBandMinus_;
  }

  public static final int FREQUENCYDEADBANDPLUS_FIELD_NUMBER = 2;
  private com.google.protobuf.FloatValue frequencyDeadBandPlus_;
  /**
   * <pre>
   * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
   * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
   * DB = frequency set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
   * @return Whether the frequencyDeadBandPlus field is set.
   */
  @java.lang.Override
  public boolean hasFrequencyDeadBandPlus() {
    return frequencyDeadBandPlus_ != null;
  }
  /**
   * <pre>
   * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
   * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
   * DB = frequency set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
   * @return The frequencyDeadBandPlus.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getFrequencyDeadBandPlus() {
    return frequencyDeadBandPlus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : frequencyDeadBandPlus_;
  }
  /**
   * <pre>
   * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
   * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
   * DB = frequency set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getFrequencyDeadBandPlusOrBuilder() {
    return frequencyDeadBandPlus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : frequencyDeadBandPlus_;
  }

  public static final int FREQUENCYREGULATIONCTL_FIELD_NUMBER = 3;
  private com.google.protobuf.BoolValue frequencyRegulationCtl_;
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
   * @return Whether the frequencyRegulationCtl field is set.
   */
  @java.lang.Override
  public boolean hasFrequencyRegulationCtl() {
    return frequencyRegulationCtl_ != null;
  }
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
   * @return The frequencyRegulationCtl.
   */
  @java.lang.Override
  public com.google.protobuf.BoolValue getFrequencyRegulationCtl() {
    return frequencyRegulationCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : frequencyRegulationCtl_;
  }
  /**
   * <pre>
   * Control value (TRUE or FALSE)
   * </pre>
   *
   * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
   */
  @java.lang.Override
  public com.google.protobuf.BoolValueOrBuilder getFrequencyRegulationCtlOrBuilder() {
    return frequencyRegulationCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : frequencyRegulationCtl_;
  }

  public static final int FREQUENCYSETPOINT_FIELD_NUMBER = 4;
  private com.google.protobuf.FloatValue frequencySetPoint_;
  /**
   * <pre>
   * uint/0.01Hz  Target frequency
   * </pre>
   *
   * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
   * @return Whether the frequencySetPoint field is set.
   */
  @java.lang.Override
  public boolean hasFrequencySetPoint() {
    return frequencySetPoint_ != null;
  }
  /**
   * <pre>
   * uint/0.01Hz  Target frequency
   * </pre>
   *
   * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
   * @return The frequencySetPoint.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getFrequencySetPoint() {
    return frequencySetPoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : frequencySetPoint_;
  }
  /**
   * <pre>
   * uint/0.01Hz  Target frequency
   * </pre>
   *
   * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getFrequencySetPointOrBuilder() {
    return frequencySetPoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : frequencySetPoint_;
  }

  public static final int GRIDFREQUENCYSTABLEBANDMINUS_FIELD_NUMBER = 5;
  private com.google.protobuf.FloatValue gridFrequencyStableBandMinus_;
  /**
   * <pre>
   * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
   * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
   * band plus Lower stable band = frequency set point – band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
   * @return Whether the gridFrequencyStableBandMinus field is set.
   */
  @java.lang.Override
  public boolean hasGridFrequencyStableBandMinus() {
    return gridFrequencyStableBandMinus_ != null;
  }
  /**
   * <pre>
   * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
   * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
   * band plus Lower stable band = frequency set point – band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
   * @return The gridFrequencyStableBandMinus.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getGridFrequencyStableBandMinus() {
    return gridFrequencyStableBandMinus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : gridFrequencyStableBandMinus_;
  }
  /**
   * <pre>
   * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
   * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
   * band plus Lower stable band = frequency set point – band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getGridFrequencyStableBandMinusOrBuilder() {
    return gridFrequencyStableBandMinus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : gridFrequencyStableBandMinus_;
  }

  public static final int GRIDFREQUENCYSTABLEBANDPLUS_FIELD_NUMBER = 6;
  private com.google.protobuf.FloatValue gridFrequencyStableBandPlus_;
  /**
   * <pre>
   * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
   * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
   * band plus Lower stable band = frequency set point – band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
   * @return Whether the gridFrequencyStableBandPlus field is set.
   */
  @java.lang.Override
  public boolean hasGridFrequencyStableBandPlus() {
    return gridFrequencyStableBandPlus_ != null;
  }
  /**
   * <pre>
   * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
   * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
   * band plus Lower stable band = frequency set point – band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
   * @return The gridFrequencyStableBandPlus.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getGridFrequencyStableBandPlus() {
    return gridFrequencyStableBandPlus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : gridFrequencyStableBandPlus_;
  }
  /**
   * <pre>
   * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
   * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
   * band plus Lower stable band = frequency set point – band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getGridFrequencyStableBandPlusOrBuilder() {
    return gridFrequencyStableBandPlus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : gridFrequencyStableBandPlus_;
  }

  public static final int OVERFREQUENCYDROOP_FIELD_NUMBER = 7;
  private com.google.protobuf.FloatValue overFrequencyDroop_;
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
   * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
   * from the upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
   * @return Whether the overFrequencyDroop field is set.
   */
  @java.lang.Override
  public boolean hasOverFrequencyDroop() {
    return overFrequencyDroop_ != null;
  }
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
   * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
   * from the upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
   * @return The overFrequencyDroop.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getOverFrequencyDroop() {
    return overFrequencyDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : overFrequencyDroop_;
  }
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
   * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
   * from the upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getOverFrequencyDroopOrBuilder() {
    return overFrequencyDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : overFrequencyDroop_;
  }

  public static final int UNDERFREQUENCYDROOP_FIELD_NUMBER = 8;
  private com.google.protobuf.FloatValue underFrequencyDroop_;
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
   * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
   * upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
   * @return Whether the underFrequencyDroop field is set.
   */
  @java.lang.Override
  public boolean hasUnderFrequencyDroop() {
    return underFrequencyDroop_ != null;
  }
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
   * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
   * upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
   * @return The underFrequencyDroop.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getUnderFrequencyDroop() {
    return underFrequencyDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : underFrequencyDroop_;
  }
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
   * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
   * upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getUnderFrequencyDroopOrBuilder() {
    return underFrequencyDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : underFrequencyDroop_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (frequencyDeadBandMinus_ != null) {
      output.writeMessage(1, getFrequencyDeadBandMinus());
    }
    if (frequencyDeadBandPlus_ != null) {
      output.writeMessage(2, getFrequencyDeadBandPlus());
    }
    if (frequencyRegulationCtl_ != null) {
      output.writeMessage(3, getFrequencyRegulationCtl());
    }
    if (frequencySetPoint_ != null) {
      output.writeMessage(4, getFrequencySetPoint());
    }
    if (gridFrequencyStableBandMinus_ != null) {
      output.writeMessage(5, getGridFrequencyStableBandMinus());
    }
    if (gridFrequencyStableBandPlus_ != null) {
      output.writeMessage(6, getGridFrequencyStableBandPlus());
    }
    if (overFrequencyDroop_ != null) {
      output.writeMessage(7, getOverFrequencyDroop());
    }
    if (underFrequencyDroop_ != null) {
      output.writeMessage(8, getUnderFrequencyDroop());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (frequencyDeadBandMinus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getFrequencyDeadBandMinus());
    }
    if (frequencyDeadBandPlus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getFrequencyDeadBandPlus());
    }
    if (frequencyRegulationCtl_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getFrequencyRegulationCtl());
    }
    if (frequencySetPoint_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getFrequencySetPoint());
    }
    if (gridFrequencyStableBandMinus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getGridFrequencyStableBandMinus());
    }
    if (gridFrequencyStableBandPlus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getGridFrequencyStableBandPlus());
    }
    if (overFrequencyDroop_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, getOverFrequencyDroop());
    }
    if (underFrequencyDroop_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(8, getUnderFrequencyDroop());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.FrequencyRegulation)) {
      return super.equals(obj);
    }
    openfmb.essmodule.FrequencyRegulation other = (openfmb.essmodule.FrequencyRegulation) obj;

    if (hasFrequencyDeadBandMinus() != other.hasFrequencyDeadBandMinus()) return false;
    if (hasFrequencyDeadBandMinus()) {
      if (!getFrequencyDeadBandMinus()
          .equals(other.getFrequencyDeadBandMinus())) return false;
    }
    if (hasFrequencyDeadBandPlus() != other.hasFrequencyDeadBandPlus()) return false;
    if (hasFrequencyDeadBandPlus()) {
      if (!getFrequencyDeadBandPlus()
          .equals(other.getFrequencyDeadBandPlus())) return false;
    }
    if (hasFrequencyRegulationCtl() != other.hasFrequencyRegulationCtl()) return false;
    if (hasFrequencyRegulationCtl()) {
      if (!getFrequencyRegulationCtl()
          .equals(other.getFrequencyRegulationCtl())) return false;
    }
    if (hasFrequencySetPoint() != other.hasFrequencySetPoint()) return false;
    if (hasFrequencySetPoint()) {
      if (!getFrequencySetPoint()
          .equals(other.getFrequencySetPoint())) return false;
    }
    if (hasGridFrequencyStableBandMinus() != other.hasGridFrequencyStableBandMinus()) return false;
    if (hasGridFrequencyStableBandMinus()) {
      if (!getGridFrequencyStableBandMinus()
          .equals(other.getGridFrequencyStableBandMinus())) return false;
    }
    if (hasGridFrequencyStableBandPlus() != other.hasGridFrequencyStableBandPlus()) return false;
    if (hasGridFrequencyStableBandPlus()) {
      if (!getGridFrequencyStableBandPlus()
          .equals(other.getGridFrequencyStableBandPlus())) return false;
    }
    if (hasOverFrequencyDroop() != other.hasOverFrequencyDroop()) return false;
    if (hasOverFrequencyDroop()) {
      if (!getOverFrequencyDroop()
          .equals(other.getOverFrequencyDroop())) return false;
    }
    if (hasUnderFrequencyDroop() != other.hasUnderFrequencyDroop()) return false;
    if (hasUnderFrequencyDroop()) {
      if (!getUnderFrequencyDroop()
          .equals(other.getUnderFrequencyDroop())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasFrequencyDeadBandMinus()) {
      hash = (37 * hash) + FREQUENCYDEADBANDMINUS_FIELD_NUMBER;
      hash = (53 * hash) + getFrequencyDeadBandMinus().hashCode();
    }
    if (hasFrequencyDeadBandPlus()) {
      hash = (37 * hash) + FREQUENCYDEADBANDPLUS_FIELD_NUMBER;
      hash = (53 * hash) + getFrequencyDeadBandPlus().hashCode();
    }
    if (hasFrequencyRegulationCtl()) {
      hash = (37 * hash) + FREQUENCYREGULATIONCTL_FIELD_NUMBER;
      hash = (53 * hash) + getFrequencyRegulationCtl().hashCode();
    }
    if (hasFrequencySetPoint()) {
      hash = (37 * hash) + FREQUENCYSETPOINT_FIELD_NUMBER;
      hash = (53 * hash) + getFrequencySetPoint().hashCode();
    }
    if (hasGridFrequencyStableBandMinus()) {
      hash = (37 * hash) + GRIDFREQUENCYSTABLEBANDMINUS_FIELD_NUMBER;
      hash = (53 * hash) + getGridFrequencyStableBandMinus().hashCode();
    }
    if (hasGridFrequencyStableBandPlus()) {
      hash = (37 * hash) + GRIDFREQUENCYSTABLEBANDPLUS_FIELD_NUMBER;
      hash = (53 * hash) + getGridFrequencyStableBandPlus().hashCode();
    }
    if (hasOverFrequencyDroop()) {
      hash = (37 * hash) + OVERFREQUENCYDROOP_FIELD_NUMBER;
      hash = (53 * hash) + getOverFrequencyDroop().hashCode();
    }
    if (hasUnderFrequencyDroop()) {
      hash = (37 * hash) + UNDERFREQUENCYDROOP_FIELD_NUMBER;
      hash = (53 * hash) + getUnderFrequencyDroop().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.FrequencyRegulation parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.FrequencyRegulation parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.FrequencyRegulation parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.FrequencyRegulation parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.FrequencyRegulation parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.FrequencyRegulation parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.FrequencyRegulation parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.FrequencyRegulation parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.FrequencyRegulation parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.FrequencyRegulation parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.FrequencyRegulation parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.FrequencyRegulation parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.FrequencyRegulation prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * ESS inverter high level function to maintain frequency within dead bands.
   * </pre>
   *
   * Protobuf type {@code essmodule.FrequencyRegulation}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.FrequencyRegulation)
      openfmb.essmodule.FrequencyRegulationOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_FrequencyRegulation_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_FrequencyRegulation_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.FrequencyRegulation.class, openfmb.essmodule.FrequencyRegulation.Builder.class);
    }

    // Construct using openfmb.essmodule.FrequencyRegulation.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      frequencyDeadBandMinus_ = null;
      if (frequencyDeadBandMinusBuilder_ != null) {
        frequencyDeadBandMinusBuilder_.dispose();
        frequencyDeadBandMinusBuilder_ = null;
      }
      frequencyDeadBandPlus_ = null;
      if (frequencyDeadBandPlusBuilder_ != null) {
        frequencyDeadBandPlusBuilder_.dispose();
        frequencyDeadBandPlusBuilder_ = null;
      }
      frequencyRegulationCtl_ = null;
      if (frequencyRegulationCtlBuilder_ != null) {
        frequencyRegulationCtlBuilder_.dispose();
        frequencyRegulationCtlBuilder_ = null;
      }
      frequencySetPoint_ = null;
      if (frequencySetPointBuilder_ != null) {
        frequencySetPointBuilder_.dispose();
        frequencySetPointBuilder_ = null;
      }
      gridFrequencyStableBandMinus_ = null;
      if (gridFrequencyStableBandMinusBuilder_ != null) {
        gridFrequencyStableBandMinusBuilder_.dispose();
        gridFrequencyStableBandMinusBuilder_ = null;
      }
      gridFrequencyStableBandPlus_ = null;
      if (gridFrequencyStableBandPlusBuilder_ != null) {
        gridFrequencyStableBandPlusBuilder_.dispose();
        gridFrequencyStableBandPlusBuilder_ = null;
      }
      overFrequencyDroop_ = null;
      if (overFrequencyDroopBuilder_ != null) {
        overFrequencyDroopBuilder_.dispose();
        overFrequencyDroopBuilder_ = null;
      }
      underFrequencyDroop_ = null;
      if (underFrequencyDroopBuilder_ != null) {
        underFrequencyDroopBuilder_.dispose();
        underFrequencyDroopBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_FrequencyRegulation_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.FrequencyRegulation getDefaultInstanceForType() {
      return openfmb.essmodule.FrequencyRegulation.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.FrequencyRegulation build() {
      openfmb.essmodule.FrequencyRegulation result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.FrequencyRegulation buildPartial() {
      openfmb.essmodule.FrequencyRegulation result = new openfmb.essmodule.FrequencyRegulation(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.FrequencyRegulation result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.frequencyDeadBandMinus_ = frequencyDeadBandMinusBuilder_ == null
            ? frequencyDeadBandMinus_
            : frequencyDeadBandMinusBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.frequencyDeadBandPlus_ = frequencyDeadBandPlusBuilder_ == null
            ? frequencyDeadBandPlus_
            : frequencyDeadBandPlusBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.frequencyRegulationCtl_ = frequencyRegulationCtlBuilder_ == null
            ? frequencyRegulationCtl_
            : frequencyRegulationCtlBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.frequencySetPoint_ = frequencySetPointBuilder_ == null
            ? frequencySetPoint_
            : frequencySetPointBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.gridFrequencyStableBandMinus_ = gridFrequencyStableBandMinusBuilder_ == null
            ? gridFrequencyStableBandMinus_
            : gridFrequencyStableBandMinusBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.gridFrequencyStableBandPlus_ = gridFrequencyStableBandPlusBuilder_ == null
            ? gridFrequencyStableBandPlus_
            : gridFrequencyStableBandPlusBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000040) != 0)) {
        result.overFrequencyDroop_ = overFrequencyDroopBuilder_ == null
            ? overFrequencyDroop_
            : overFrequencyDroopBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000080) != 0)) {
        result.underFrequencyDroop_ = underFrequencyDroopBuilder_ == null
            ? underFrequencyDroop_
            : underFrequencyDroopBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.FrequencyRegulation) {
        return mergeFrom((openfmb.essmodule.FrequencyRegulation)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.FrequencyRegulation other) {
      if (other == openfmb.essmodule.FrequencyRegulation.getDefaultInstance()) return this;
      if (other.hasFrequencyDeadBandMinus()) {
        mergeFrequencyDeadBandMinus(other.getFrequencyDeadBandMinus());
      }
      if (other.hasFrequencyDeadBandPlus()) {
        mergeFrequencyDeadBandPlus(other.getFrequencyDeadBandPlus());
      }
      if (other.hasFrequencyRegulationCtl()) {
        mergeFrequencyRegulationCtl(other.getFrequencyRegulationCtl());
      }
      if (other.hasFrequencySetPoint()) {
        mergeFrequencySetPoint(other.getFrequencySetPoint());
      }
      if (other.hasGridFrequencyStableBandMinus()) {
        mergeGridFrequencyStableBandMinus(other.getGridFrequencyStableBandMinus());
      }
      if (other.hasGridFrequencyStableBandPlus()) {
        mergeGridFrequencyStableBandPlus(other.getGridFrequencyStableBandPlus());
      }
      if (other.hasOverFrequencyDroop()) {
        mergeOverFrequencyDroop(other.getOverFrequencyDroop());
      }
      if (other.hasUnderFrequencyDroop()) {
        mergeUnderFrequencyDroop(other.getUnderFrequencyDroop());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getFrequencyDeadBandMinusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getFrequencyDeadBandPlusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getFrequencyRegulationCtlFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getFrequencySetPointFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getGridFrequencyStableBandMinusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            case 50: {
              input.readMessage(
                  getGridFrequencyStableBandPlusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000020;
              break;
            } // case 50
            case 58: {
              input.readMessage(
                  getOverFrequencyDroopFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000040;
              break;
            } // case 58
            case 66: {
              input.readMessage(
                  getUnderFrequencyDroopFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000080;
              break;
            } // case 66
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private com.google.protobuf.FloatValue frequencyDeadBandMinus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> frequencyDeadBandMinusBuilder_;
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
     * @return Whether the frequencyDeadBandMinus field is set.
     */
    public boolean hasFrequencyDeadBandMinus() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
     * @return The frequencyDeadBandMinus.
     */
    public com.google.protobuf.FloatValue getFrequencyDeadBandMinus() {
      if (frequencyDeadBandMinusBuilder_ == null) {
        return frequencyDeadBandMinus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : frequencyDeadBandMinus_;
      } else {
        return frequencyDeadBandMinusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
     */
    public Builder setFrequencyDeadBandMinus(com.google.protobuf.FloatValue value) {
      if (frequencyDeadBandMinusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        frequencyDeadBandMinus_ = value;
      } else {
        frequencyDeadBandMinusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
     */
    public Builder setFrequencyDeadBandMinus(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (frequencyDeadBandMinusBuilder_ == null) {
        frequencyDeadBandMinus_ = builderForValue.build();
      } else {
        frequencyDeadBandMinusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
     */
    public Builder mergeFrequencyDeadBandMinus(com.google.protobuf.FloatValue value) {
      if (frequencyDeadBandMinusBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          frequencyDeadBandMinus_ != null &&
          frequencyDeadBandMinus_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getFrequencyDeadBandMinusBuilder().mergeFrom(value);
        } else {
          frequencyDeadBandMinus_ = value;
        }
      } else {
        frequencyDeadBandMinusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
     */
    public Builder clearFrequencyDeadBandMinus() {
      bitField0_ = (bitField0_ & ~0x00000001);
      frequencyDeadBandMinus_ = null;
      if (frequencyDeadBandMinusBuilder_ != null) {
        frequencyDeadBandMinusBuilder_.dispose();
        frequencyDeadBandMinusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
     */
    public com.google.protobuf.FloatValue.Builder getFrequencyDeadBandMinusBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getFrequencyDeadBandMinusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getFrequencyDeadBandMinusOrBuilder() {
      if (frequencyDeadBandMinusBuilder_ != null) {
        return frequencyDeadBandMinusBuilder_.getMessageOrBuilder();
      } else {
        return frequencyDeadBandMinus_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : frequencyDeadBandMinus_;
      }
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandMinus = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getFrequencyDeadBandMinusFieldBuilder() {
      if (frequencyDeadBandMinusBuilder_ == null) {
        frequencyDeadBandMinusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getFrequencyDeadBandMinus(),
                getParentForChildren(),
                isClean());
        frequencyDeadBandMinus_ = null;
      }
      return frequencyDeadBandMinusBuilder_;
    }

    private com.google.protobuf.FloatValue frequencyDeadBandPlus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> frequencyDeadBandPlusBuilder_;
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
     * @return Whether the frequencyDeadBandPlus field is set.
     */
    public boolean hasFrequencyDeadBandPlus() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
     * @return The frequencyDeadBandPlus.
     */
    public com.google.protobuf.FloatValue getFrequencyDeadBandPlus() {
      if (frequencyDeadBandPlusBuilder_ == null) {
        return frequencyDeadBandPlus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : frequencyDeadBandPlus_;
      } else {
        return frequencyDeadBandPlusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
     */
    public Builder setFrequencyDeadBandPlus(com.google.protobuf.FloatValue value) {
      if (frequencyDeadBandPlusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        frequencyDeadBandPlus_ = value;
      } else {
        frequencyDeadBandPlusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
     */
    public Builder setFrequencyDeadBandPlus(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (frequencyDeadBandPlusBuilder_ == null) {
        frequencyDeadBandPlus_ = builderForValue.build();
      } else {
        frequencyDeadBandPlusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
     */
    public Builder mergeFrequencyDeadBandPlus(com.google.protobuf.FloatValue value) {
      if (frequencyDeadBandPlusBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          frequencyDeadBandPlus_ != null &&
          frequencyDeadBandPlus_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getFrequencyDeadBandPlusBuilder().mergeFrom(value);
        } else {
          frequencyDeadBandPlus_ = value;
        }
      } else {
        frequencyDeadBandPlusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
     */
    public Builder clearFrequencyDeadBandPlus() {
      bitField0_ = (bitField0_ & ~0x00000002);
      frequencyDeadBandPlus_ = null;
      if (frequencyDeadBandPlusBuilder_ != null) {
        frequencyDeadBandPlusBuilder_.dispose();
        frequencyDeadBandPlusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
     */
    public com.google.protobuf.FloatValue.Builder getFrequencyDeadBandPlusBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getFrequencyDeadBandPlusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getFrequencyDeadBandPlusOrBuilder() {
      if (frequencyDeadBandPlusBuilder_ != null) {
        return frequencyDeadBandPlusBuilder_.getMessageOrBuilder();
      } else {
        return frequencyDeadBandPlus_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : frequencyDeadBandPlus_;
      }
    }
    /**
     * <pre>
     * uint/0.01Hz  Frequency regulation is performed when the grid frequency goes beyond the dead
     * bands. The dead bands are defined as follows: Upper DB = frequency set point + dead band plus Lower
     * DB = frequency set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencyDeadBandPlus = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getFrequencyDeadBandPlusFieldBuilder() {
      if (frequencyDeadBandPlusBuilder_ == null) {
        frequencyDeadBandPlusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getFrequencyDeadBandPlus(),
                getParentForChildren(),
                isClean());
        frequencyDeadBandPlus_ = null;
      }
      return frequencyDeadBandPlusBuilder_;
    }

    private com.google.protobuf.BoolValue frequencyRegulationCtl_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> frequencyRegulationCtlBuilder_;
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
     * @return Whether the frequencyRegulationCtl field is set.
     */
    public boolean hasFrequencyRegulationCtl() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
     * @return The frequencyRegulationCtl.
     */
    public com.google.protobuf.BoolValue getFrequencyRegulationCtl() {
      if (frequencyRegulationCtlBuilder_ == null) {
        return frequencyRegulationCtl_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : frequencyRegulationCtl_;
      } else {
        return frequencyRegulationCtlBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
     */
    public Builder setFrequencyRegulationCtl(com.google.protobuf.BoolValue value) {
      if (frequencyRegulationCtlBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        frequencyRegulationCtl_ = value;
      } else {
        frequencyRegulationCtlBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
     */
    public Builder setFrequencyRegulationCtl(
        com.google.protobuf.BoolValue.Builder builderForValue) {
      if (frequencyRegulationCtlBuilder_ == null) {
        frequencyRegulationCtl_ = builderForValue.build();
      } else {
        frequencyRegulationCtlBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
     */
    public Builder mergeFrequencyRegulationCtl(com.google.protobuf.BoolValue value) {
      if (frequencyRegulationCtlBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          frequencyRegulationCtl_ != null &&
          frequencyRegulationCtl_ != com.google.protobuf.BoolValue.getDefaultInstance()) {
          getFrequencyRegulationCtlBuilder().mergeFrom(value);
        } else {
          frequencyRegulationCtl_ = value;
        }
      } else {
        frequencyRegulationCtlBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
     */
    public Builder clearFrequencyRegulationCtl() {
      bitField0_ = (bitField0_ & ~0x00000004);
      frequencyRegulationCtl_ = null;
      if (frequencyRegulationCtlBuilder_ != null) {
        frequencyRegulationCtlBuilder_.dispose();
        frequencyRegulationCtlBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
     */
    public com.google.protobuf.BoolValue.Builder getFrequencyRegulationCtlBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getFrequencyRegulationCtlFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
     */
    public com.google.protobuf.BoolValueOrBuilder getFrequencyRegulationCtlOrBuilder() {
      if (frequencyRegulationCtlBuilder_ != null) {
        return frequencyRegulationCtlBuilder_.getMessageOrBuilder();
      } else {
        return frequencyRegulationCtl_ == null ?
            com.google.protobuf.BoolValue.getDefaultInstance() : frequencyRegulationCtl_;
      }
    }
    /**
     * <pre>
     * Control value (TRUE or FALSE)
     * </pre>
     *
     * <code>.google.protobuf.BoolValue frequencyRegulationCtl = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> 
        getFrequencyRegulationCtlFieldBuilder() {
      if (frequencyRegulationCtlBuilder_ == null) {
        frequencyRegulationCtlBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder>(
                getFrequencyRegulationCtl(),
                getParentForChildren(),
                isClean());
        frequencyRegulationCtl_ = null;
      }
      return frequencyRegulationCtlBuilder_;
    }

    private com.google.protobuf.FloatValue frequencySetPoint_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> frequencySetPointBuilder_;
    /**
     * <pre>
     * uint/0.01Hz  Target frequency
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
     * @return Whether the frequencySetPoint field is set.
     */
    public boolean hasFrequencySetPoint() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * uint/0.01Hz  Target frequency
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
     * @return The frequencySetPoint.
     */
    public com.google.protobuf.FloatValue getFrequencySetPoint() {
      if (frequencySetPointBuilder_ == null) {
        return frequencySetPoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : frequencySetPoint_;
      } else {
        return frequencySetPointBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.01Hz  Target frequency
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
     */
    public Builder setFrequencySetPoint(com.google.protobuf.FloatValue value) {
      if (frequencySetPointBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        frequencySetPoint_ = value;
      } else {
        frequencySetPointBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Target frequency
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
     */
    public Builder setFrequencySetPoint(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (frequencySetPointBuilder_ == null) {
        frequencySetPoint_ = builderForValue.build();
      } else {
        frequencySetPointBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Target frequency
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
     */
    public Builder mergeFrequencySetPoint(com.google.protobuf.FloatValue value) {
      if (frequencySetPointBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          frequencySetPoint_ != null &&
          frequencySetPoint_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getFrequencySetPointBuilder().mergeFrom(value);
        } else {
          frequencySetPoint_ = value;
        }
      } else {
        frequencySetPointBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Target frequency
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
     */
    public Builder clearFrequencySetPoint() {
      bitField0_ = (bitField0_ & ~0x00000008);
      frequencySetPoint_ = null;
      if (frequencySetPointBuilder_ != null) {
        frequencySetPointBuilder_.dispose();
        frequencySetPointBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Target frequency
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
     */
    public com.google.protobuf.FloatValue.Builder getFrequencySetPointBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getFrequencySetPointFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.01Hz  Target frequency
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getFrequencySetPointOrBuilder() {
      if (frequencySetPointBuilder_ != null) {
        return frequencySetPointBuilder_.getMessageOrBuilder();
      } else {
        return frequencySetPoint_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : frequencySetPoint_;
      }
    }
    /**
     * <pre>
     * uint/0.01Hz  Target frequency
     * </pre>
     *
     * <code>.google.protobuf.FloatValue frequencySetPoint = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getFrequencySetPointFieldBuilder() {
      if (frequencySetPointBuilder_ == null) {
        frequencySetPointBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getFrequencySetPoint(),
                getParentForChildren(),
                isClean());
        frequencySetPoint_ = null;
      }
      return frequencySetPointBuilder_;
    }

    private com.google.protobuf.FloatValue gridFrequencyStableBandMinus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> gridFrequencyStableBandMinusBuilder_;
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
     * @return Whether the gridFrequencyStableBandMinus field is set.
     */
    public boolean hasGridFrequencyStableBandMinus() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
     * @return The gridFrequencyStableBandMinus.
     */
    public com.google.protobuf.FloatValue getGridFrequencyStableBandMinus() {
      if (gridFrequencyStableBandMinusBuilder_ == null) {
        return gridFrequencyStableBandMinus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : gridFrequencyStableBandMinus_;
      } else {
        return gridFrequencyStableBandMinusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
     */
    public Builder setGridFrequencyStableBandMinus(com.google.protobuf.FloatValue value) {
      if (gridFrequencyStableBandMinusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        gridFrequencyStableBandMinus_ = value;
      } else {
        gridFrequencyStableBandMinusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
     */
    public Builder setGridFrequencyStableBandMinus(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (gridFrequencyStableBandMinusBuilder_ == null) {
        gridFrequencyStableBandMinus_ = builderForValue.build();
      } else {
        gridFrequencyStableBandMinusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
     */
    public Builder mergeGridFrequencyStableBandMinus(com.google.protobuf.FloatValue value) {
      if (gridFrequencyStableBandMinusBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          gridFrequencyStableBandMinus_ != null &&
          gridFrequencyStableBandMinus_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getGridFrequencyStableBandMinusBuilder().mergeFrom(value);
        } else {
          gridFrequencyStableBandMinus_ = value;
        }
      } else {
        gridFrequencyStableBandMinusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
     */
    public Builder clearGridFrequencyStableBandMinus() {
      bitField0_ = (bitField0_ & ~0x00000010);
      gridFrequencyStableBandMinus_ = null;
      if (gridFrequencyStableBandMinusBuilder_ != null) {
        gridFrequencyStableBandMinusBuilder_.dispose();
        gridFrequencyStableBandMinusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
     */
    public com.google.protobuf.FloatValue.Builder getGridFrequencyStableBandMinusBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getGridFrequencyStableBandMinusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getGridFrequencyStableBandMinusOrBuilder() {
      if (gridFrequencyStableBandMinusBuilder_ != null) {
        return gridFrequencyStableBandMinusBuilder_.getMessageOrBuilder();
      } else {
        return gridFrequencyStableBandMinus_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : gridFrequencyStableBandMinus_;
      }
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandMinus = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getGridFrequencyStableBandMinusFieldBuilder() {
      if (gridFrequencyStableBandMinusBuilder_ == null) {
        gridFrequencyStableBandMinusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getGridFrequencyStableBandMinus(),
                getParentForChildren(),
                isClean());
        gridFrequencyStableBandMinus_ = null;
      }
      return gridFrequencyStableBandMinusBuilder_;
    }

    private com.google.protobuf.FloatValue gridFrequencyStableBandPlus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> gridFrequencyStableBandPlusBuilder_;
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
     * @return Whether the gridFrequencyStableBandPlus field is set.
     */
    public boolean hasGridFrequencyStableBandPlus() {
      return ((bitField0_ & 0x00000020) != 0);
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
     * @return The gridFrequencyStableBandPlus.
     */
    public com.google.protobuf.FloatValue getGridFrequencyStableBandPlus() {
      if (gridFrequencyStableBandPlusBuilder_ == null) {
        return gridFrequencyStableBandPlus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : gridFrequencyStableBandPlus_;
      } else {
        return gridFrequencyStableBandPlusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
     */
    public Builder setGridFrequencyStableBandPlus(com.google.protobuf.FloatValue value) {
      if (gridFrequencyStableBandPlusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        gridFrequencyStableBandPlus_ = value;
      } else {
        gridFrequencyStableBandPlusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
     */
    public Builder setGridFrequencyStableBandPlus(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (gridFrequencyStableBandPlusBuilder_ == null) {
        gridFrequencyStableBandPlus_ = builderForValue.build();
      } else {
        gridFrequencyStableBandPlusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
     */
    public Builder mergeGridFrequencyStableBandPlus(com.google.protobuf.FloatValue value) {
      if (gridFrequencyStableBandPlusBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0) &&
          gridFrequencyStableBandPlus_ != null &&
          gridFrequencyStableBandPlus_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getGridFrequencyStableBandPlusBuilder().mergeFrom(value);
        } else {
          gridFrequencyStableBandPlus_ = value;
        }
      } else {
        gridFrequencyStableBandPlusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
     */
    public Builder clearGridFrequencyStableBandPlus() {
      bitField0_ = (bitField0_ & ~0x00000020);
      gridFrequencyStableBandPlus_ = null;
      if (gridFrequencyStableBandPlusBuilder_ != null) {
        gridFrequencyStableBandPlusBuilder_.dispose();
        gridFrequencyStableBandPlusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
     */
    public com.google.protobuf.FloatValue.Builder getGridFrequencyStableBandPlusBuilder() {
      bitField0_ |= 0x00000020;
      onChanged();
      return getGridFrequencyStableBandPlusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getGridFrequencyStableBandPlusOrBuilder() {
      if (gridFrequencyStableBandPlusBuilder_ != null) {
        return gridFrequencyStableBandPlusBuilder_.getMessageOrBuilder();
      } else {
        return gridFrequencyStableBandPlus_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : gridFrequencyStableBandPlus_;
      }
    }
    /**
     * <pre>
     * uint/0.01Hz  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue gridFrequencyStableBandPlus = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getGridFrequencyStableBandPlusFieldBuilder() {
      if (gridFrequencyStableBandPlusBuilder_ == null) {
        gridFrequencyStableBandPlusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getGridFrequencyStableBandPlus(),
                getParentForChildren(),
                isClean());
        gridFrequencyStableBandPlus_ = null;
      }
      return gridFrequencyStableBandPlusBuilder_;
    }

    private com.google.protobuf.FloatValue overFrequencyDroop_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> overFrequencyDroopBuilder_;
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
     * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
     * from the upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
     * @return Whether the overFrequencyDroop field is set.
     */
    public boolean hasOverFrequencyDroop() {
      return ((bitField0_ & 0x00000040) != 0);
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
     * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
     * from the upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
     * @return The overFrequencyDroop.
     */
    public com.google.protobuf.FloatValue getOverFrequencyDroop() {
      if (overFrequencyDroopBuilder_ == null) {
        return overFrequencyDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : overFrequencyDroop_;
      } else {
        return overFrequencyDroopBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
     * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
     * from the upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
     */
    public Builder setOverFrequencyDroop(com.google.protobuf.FloatValue value) {
      if (overFrequencyDroopBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        overFrequencyDroop_ = value;
      } else {
        overFrequencyDroopBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
     * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
     * from the upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
     */
    public Builder setOverFrequencyDroop(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (overFrequencyDroopBuilder_ == null) {
        overFrequencyDroop_ = builderForValue.build();
      } else {
        overFrequencyDroopBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
     * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
     * from the upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
     */
    public Builder mergeOverFrequencyDroop(com.google.protobuf.FloatValue value) {
      if (overFrequencyDroopBuilder_ == null) {
        if (((bitField0_ & 0x00000040) != 0) &&
          overFrequencyDroop_ != null &&
          overFrequencyDroop_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getOverFrequencyDroopBuilder().mergeFrom(value);
        } else {
          overFrequencyDroop_ = value;
        }
      } else {
        overFrequencyDroopBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
     * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
     * from the upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
     */
    public Builder clearOverFrequencyDroop() {
      bitField0_ = (bitField0_ & ~0x00000040);
      overFrequencyDroop_ = null;
      if (overFrequencyDroopBuilder_ != null) {
        overFrequencyDroopBuilder_.dispose();
        overFrequencyDroopBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
     * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
     * from the upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
     */
    public com.google.protobuf.FloatValue.Builder getOverFrequencyDroopBuilder() {
      bitField0_ |= 0x00000040;
      onChanged();
      return getOverFrequencyDroopFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
     * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
     * from the upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getOverFrequencyDroopOrBuilder() {
      if (overFrequencyDroopBuilder_ != null) {
        return overFrequencyDroopBuilder_.getMessageOrBuilder();
      } else {
        return overFrequencyDroop_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : overFrequencyDroop_;
      }
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over frequency events. A droop of
     * 1% means that the PCS will output 100% power if the frequency is 1% of the nominal frequency away
     * from the upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overFrequencyDroop = 7;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getOverFrequencyDroopFieldBuilder() {
      if (overFrequencyDroopBuilder_ == null) {
        overFrequencyDroopBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getOverFrequencyDroop(),
                getParentForChildren(),
                isClean());
        overFrequencyDroop_ = null;
      }
      return overFrequencyDroopBuilder_;
    }

    private com.google.protobuf.FloatValue underFrequencyDroop_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> underFrequencyDroopBuilder_;
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
     * @return Whether the underFrequencyDroop field is set.
     */
    public boolean hasUnderFrequencyDroop() {
      return ((bitField0_ & 0x00000080) != 0);
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
     * @return The underFrequencyDroop.
     */
    public com.google.protobuf.FloatValue getUnderFrequencyDroop() {
      if (underFrequencyDroopBuilder_ == null) {
        return underFrequencyDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : underFrequencyDroop_;
      } else {
        return underFrequencyDroopBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
     */
    public Builder setUnderFrequencyDroop(com.google.protobuf.FloatValue value) {
      if (underFrequencyDroopBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        underFrequencyDroop_ = value;
      } else {
        underFrequencyDroopBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
     */
    public Builder setUnderFrequencyDroop(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (underFrequencyDroopBuilder_ == null) {
        underFrequencyDroop_ = builderForValue.build();
      } else {
        underFrequencyDroopBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
     */
    public Builder mergeUnderFrequencyDroop(com.google.protobuf.FloatValue value) {
      if (underFrequencyDroopBuilder_ == null) {
        if (((bitField0_ & 0x00000080) != 0) &&
          underFrequencyDroop_ != null &&
          underFrequencyDroop_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getUnderFrequencyDroopBuilder().mergeFrom(value);
        } else {
          underFrequencyDroop_ = value;
        }
      } else {
        underFrequencyDroopBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
     */
    public Builder clearUnderFrequencyDroop() {
      bitField0_ = (bitField0_ & ~0x00000080);
      underFrequencyDroop_ = null;
      if (underFrequencyDroopBuilder_ != null) {
        underFrequencyDroopBuilder_.dispose();
        underFrequencyDroopBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
     */
    public com.google.protobuf.FloatValue.Builder getUnderFrequencyDroopBuilder() {
      bitField0_ |= 0x00000080;
      onChanged();
      return getUnderFrequencyDroopFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getUnderFrequencyDroopOrBuilder() {
      if (underFrequencyDroopBuilder_ != null) {
        return underFrequencyDroopBuilder_.getMessageOrBuilder();
      } else {
        return underFrequencyDroop_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : underFrequencyDroop_;
      }
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underFrequencyDroop = 8;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getUnderFrequencyDroopFieldBuilder() {
      if (underFrequencyDroopBuilder_ == null) {
        underFrequencyDroopBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getUnderFrequencyDroop(),
                getParentForChildren(),
                isClean());
        underFrequencyDroop_ = null;
      }
      return underFrequencyDroopBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.FrequencyRegulation)
  }

  // @@protoc_insertion_point(class_scope:essmodule.FrequencyRegulation)
  private static final openfmb.essmodule.FrequencyRegulation DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.FrequencyRegulation();
  }

  public static openfmb.essmodule.FrequencyRegulation getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<FrequencyRegulation>
      PARSER = new com.google.protobuf.AbstractParser<FrequencyRegulation>() {
    @java.lang.Override
    public FrequencyRegulation parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<FrequencyRegulation> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<FrequencyRegulation> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.FrequencyRegulation getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

